diff -urN qpopper4.0.5/popper/pop_config.c qpopper4.0.5-log/popper/pop_config.c
--- qpopper4.0.5/popper/pop_config.c	Wed Mar 12 21:06:37 2003
+++ qpopper4.0.5-log/popper/pop_config.c	Wed Jan 28 08:10:11 2004
@@ -229,7 +229,7 @@
     kLOG_FACILITY,          /* -y facility      */
     kLOG_LOGIN,             /*    (no flag)     */
     kMAXBULLS,              /*    (no flag)     */
-
+    kLOG_LEVEL,             /*    (no flag)     */
 
     LAST_OPT_VAL
 } opt_val_type;
@@ -302,6 +302,7 @@
     { "user-options"                 , CfgBool , CfgResUser, kUSEROPTS           },
     { "UW-kluge"                     , CfgBool , CfgResNone, kUW_KLUGE           },
     { "UW-kludge"                    , CfgBool , CfgResNone, kUW_KLUGE           },
+    { "log-level"                    , CfgMnem , CfgResNone, kLOG_LEVEL          },
 
     { NULL                           , CfgBad  , CfgResNone, LAST_OPT_VAL        }
 };
@@ -395,7 +396,18 @@
 
     { NULL              , PopLogMail            }
 };
+
+static mnemonic_map mnem_map_log_level [] =
+{
     
+    { "priority"        , POP_NOTICE            },
+    { "warning"         , POP_WARNING           },
+    { "notice"          , POP_NOTICE            },
+    { "info"            , POP_INFO              },
+    { "debug"           , POP_DEBUG             },
+
+    { NULL              ,                       }
+};
 
 /*
  * Map each option to its specific table
@@ -407,8 +419,9 @@
     { kTLS_VERSION      , mnem_map_tls_vers       },
     { kCHUNKY_WRITES    , mnem_map_chunky_writes  },
     { kLOG_FACILITY     , mnem_map_log_facility   },
+    { kLOG_LEVEL        , mnem_map_log_level      },
 
-    { -1                , NULL                     }
+    { -1                , NULL                    }
 };
 
 
@@ -908,6 +921,7 @@
         case kLOG_FACILITY:        R__MNM ( &p->log_facility );
         case kLOG_LOGIN:           R__PTR ( &p->pLog_login );
         case kMAXBULLS:            R__INT ( &p->nMaxBulls );
+        case kLOG_LEVEL:           R__MNM ( &p->pLog_Level );
 
         default:                   R__PTR ( NULL );
     } /* switch ( item ) */
diff -urN qpopper4.0.5/popper/pop_log.c qpopper4.0.5-log/popper/pop_log.c
--- qpopper4.0.5/popper/pop_log.c	Wed Mar 12 21:06:37 2003
+++ qpopper4.0.5-log/popper/pop_log.c	Wed Jan 28 08:00:45 2004
@@ -142,7 +142,8 @@
         fflush  ( p->trace );
     }
     else {
-        syslog ( (int) loglev, "%s", msgbuf );
+	if(!p || p->debug || !p->pLog_Level || p->pLog_Level >= loglev || !loglev ) 	
+           syslog ( (int) loglev, "%s", msgbuf );
     }
     
     if ( iChunk == -1 ) {
diff -urN qpopper4.0.5/popper/popper.h qpopper4.0.5-log/popper/popper.h
--- qpopper4.0.5/popper/popper.h	Wed Mar 12 21:06:38 2003
+++ qpopper4.0.5-log/popper/popper.h	Wed Jan 28 08:11:29 2004
@@ -683,6 +683,7 @@
     BOOL               bNo_atomic_open;         /* open() isn't automic. */
     log_facility_type   log_facility;           /* Which log facility to use */
     char               *pLog_login;             /* String to use when logging log-ins */
+    log_level           pLog_Level;             /* which loglevels get logged when not in debug mode*/
 };
 
 
